<?php
/**
* データソースを生成するファクトリクラス
*
* PHP version 5
*
* @package    core
* @author     stk2k <stk2k@sazysoft.com>
* @copyright  2008 stk2k, sazysoft
*/

class charcoal_DataSourceFactory 
{
	/*
	 * データソースを作成
	 */
	public static function create( $data_source_name )
	{
		log_info( "system",  "データソース[$data_source_name]をロードします。", __FILE__, __LINE__ );

		// Configをロード
		$config = charcoal_ConfigLoader::loadConfig( $data_source_name, "data_source" );

		// クラス名を取得
		$class_name = $config->getString( "class_name" );

		// データソースのインスタンス生成
		$data_source = charcoal_ClassUtil::newInstance( $class_name );

		// 生成したインスタンスがIValidatorインタフェースを実装しているか確認
		if ( !($data_source instanceof charcoal_IDataSource) ){
			// 実装例外
			throw new charcoal_InterfaceImplementException( $class_name, "charcoal_IDataSource" );
		}

		log_info( "system",  "データソース[$data_source_name]を初期化します。", __FILE__, __LINE__ );

		// データソースを初期化
		$data_source->init( $config );

		log_info( "system",  "データソース[$data_source_name]をロードしました。", __FILE__, __LINE__ );

		// ロードしたデータソースを返却
		return $data_source;
	}
}
